#!/bin/sh
# $Id: t-bounce-9.sh,v 1.8 2011/09/12 03:36:51 ca Exp $
# Copyright (c) 2005 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#
# ----------------------------------------
# test bounces due to errors during session greeting;
# check text of bounces delivered via lmtp to smtps3
# run smtp1.sh with different parameters
# ----------------------------------------
#
test -s stop && exit 1
#

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

OK="t-bounce-9.ok"
OUT="t-bounce-9.out"

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to working directory for alias file!
cd ../qmgr || exit 1

# create aliases
${CAT} > ${ALI} <<EOF
abuse:	local:
postmaster:	local:
user:	local:
sender: local:
alias1: user+alias1
aliase3: <553@local.dom>
553: local:
EOF
# create map
rm -f ${ALIMAP}
${MM} < ${ALI}
rm -f ${MTMAP}

# run some test programs


# ----------------------------------------
# permanent failure from SMTP sink during greeting; create bounce; check content
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
#XREF define QCNF_FL_B_DSN_RFC	0x00004000
if ${SHELL} ${SD}/smtp1.sh -3 lmtpsock -Ssender@local.dom -Ruser@local.host -Q '-T 4 -F 0x4000' -i 8 -s 30 -E 0 -X 0 -A 1 -Y '-G 551 -d 4'
then
  if test -s ${B1}
  then
    preparedsn
    ${CAT} > ${OK} <<EOF
Return-Path: <>
From: Mailer-Daemon@
Subject: Undeliverable mail
To: <sender@local.dom>
MIME-Version: 1.0
Content-Type: multipart/report; report-type=delivery-status; boundary="${DELIM}"

This is a MIME-encapsulated message

--${DELIM}

${DSN_ERR}

Recipient:
<user@local.host>
Remote-MTA: 127.0.0.1
Reason:
551 local.host ESMTP ST sink
during session greeting
maximum time in queue exceeded

--${DELIM}
Content-Type: message/delivery-status

Reporting-MTA: dns; ${HOSTNAME}

Final-Recipient: rfc822;<user@local.host>
Action: failed
Remote-MTA: dns; 127.0.0.1
Status: 4.0.0
Diagnostic-Code: smtp; 551 local.host ESMTP ST sink

--${DELIM}
Content-Type: message/rfc822

EOF
    if ${DIFF} -w ${OK} ${OUT} >/dev/null
    then
      :
    else
      ERR=true
    fi

  else
     ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi

# ----------------------------------------
# temporary failure from SMTP sink during greeting; create bounce; check content
TEST=2
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
#XREF define QCNF_FL_B_DSN_RFC	0x00004000
if ${SHELL} ${SD}/smtp1.sh -3 lmtpsock -Ssender@local.dom -Ruser@local.host -Q '-T 4 -F 0x4000' -i 8 -s 30 -E 0 -X 0 -A 1 -Y '-G 451 -d 4'
then
  if test -s ${B1}
  then
    preparedsn
    ${CAT} > ${OK} <<EOF
Return-Path: <>
From: Mailer-Daemon@
Subject: Undeliverable mail
To: <sender@local.dom>
MIME-Version: 1.0
Content-Type: multipart/report; report-type=delivery-status; boundary="${DELIM}"

This is a MIME-encapsulated message

--${DELIM}

${DSN_ERR}

Recipient:
<user@local.host>
Remote-MTA: 127.0.0.1
Reason:
451 local.host ESMTP ST sink
during session greeting
maximum time in queue exceeded

--${DELIM}
Content-Type: message/delivery-status

Reporting-MTA: dns; ${HOSTNAME}

Final-Recipient: rfc822;<user@local.host>
Action: failed
Remote-MTA: dns; 127.0.0.1
Status: 4.0.0
Diagnostic-Code: smtp; 451 local.host ESMTP ST sink

--${DELIM}
Content-Type: message/rfc822

EOF
    if ${DIFF} -w ${OK} ${OUT} >/dev/null
    then
      :
    else
      ERR=true
    fi
  else
     ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# temporary failure from SMTP sink during greeting; create bounce; check content
TEST=3
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
#XREF define QCNF_FL_B_DSN_RFC	0x00004000
if ${SHELL} ${SD}/smtp1.sh -3 lmtpsock -Ssender@local.dom -Ruser@local.host -Q '-T 4 -F 0x4000' -i 8 -s 20 -E 0 -X 0 -A 1 -Y '-G 421 -d 4'
then
  if test -s ${B1}
  then
    preparedsn
    ${CAT} > ${OK} <<EOF
Return-Path: <>
From: Mailer-Daemon@
Subject: Undeliverable mail
To: <sender@local.dom>
MIME-Version: 1.0
Content-Type: multipart/report; report-type=delivery-status; boundary="${DELIM}"

This is a MIME-encapsulated message

--${DELIM}

${DSN_ERR}

Recipient:
<user@local.host>
Remote-MTA: 127.0.0.1
Reason:
421 local.host ESMTP ST sink
during session greeting
maximum time in queue exceeded

--${DELIM}
Content-Type: message/delivery-status

Reporting-MTA: dns; ${HOSTNAME}

Final-Recipient: rfc822;<user@local.host>
Action: failed
Remote-MTA: dns; 127.0.0.1
Status: 4.0.0
Diagnostic-Code: smtp; 421 local.host ESMTP ST sink

--${DELIM}
Content-Type: message/rfc822

EOF
    if ${DIFF} -w ${OK} ${OUT} >/dev/null
    then
      :
    else
      ERR=true
    fi

  else
     ERR=true
  fi
else
  ERR=true
fi
if ${ERR}
then
   echo "$0: test ${TEST} failed"
   ERRS=`expr ${ERRS} + 1 `
   test X"${MTA_STOPONERROR}" != X && exit 1
fi
fi


# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  rm -f ${OK} ${OUT}
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
