/*
 */

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-cbsl-0.c,v 1.2 2010/09/24 01:38:34 ca Exp $")
#include "sm/assert.h"
#include "sm/error.h"
#include "sm/io.h"
#include "sm/misc.h"
#include "sm/test.h"

static int Verbosity = 0;

#define LEN	256

struct cbsl_S {
	char *e_string;
	char *e_result;
};
typedef struct cbsl_S cbsl_T;

static cbsl_T cbsls[] = {
	{ "",	""},
	{ "a",	"a"},
	{ "abc",	"abc"},
	{ "\\5",	"\\5"},
	{ "\\\\",	"\\"},
	{ "\\007",	"\007"},
	{ "\\033",	"\033"},
	{ "\\00",	""},
	{ "\\009",	""},
	{ NULL, NULL}
};

static void
test(void)
{
	bool b;
	int i;
	char cbsl[256];

	for (i = 0; cbsls[i].e_string != NULL; i++) {
		b = convbackslash(cbsls[i].e_string, cbsl);
		SM_TEST(strcmp(cbsls[i].e_result, cbsl) == 0);
		if (strcmp(cbsls[i].e_result, cbsl))
			sm_io_fprintf(smioerr, "'%s'!='%s'\n", cbsls[i].e_result, cbsl);
	}
	return;
}

int
main(int argc, char *argv[])
{
	int c;

	while ((c = getopt(argc, argv, "V")) != -1) {
		switch (c) {
		  case 'V':
			++Verbosity;
			break;
		}
	}
	sm_test_begin(argc, argv, "test backslash conversion");

	argc -= optind;
	argv += optind;

	test();

	return sm_test_end();
}
