#!/bin/sh
# $Id: t-mcpconf-2.sh,v 1.3 2013/12/22 02:44:03 ca Exp $
#
# Copyright (c) 2010 Sendmail, Inc. and its suppliers.
#	All rights reserved.
#
# By using this file, you agree to the terms and conditions set
# forth in the LICENSE file which can be found at the top level of
# the sendmail distribution.
#

# ------------------------------------------------------------
# check error handling: conf file contains errors,
# mcp must fail unless told to ignore them.
# ------------------------------------------------------------

test -s stop && exit 1

# source directory of this (and other) shell script
SD=`dirname $0`
. ${SD}/../check2/user.sh

ERRS=0

CNF=mcp0.conf
OUT=mcp0.out
PIDS=pids
PID=pid
rm -f ${PIDS} ${OUT}

PRG=./mcpconf

cat > ${CNF} <<EOF
smtps {
  IO_timeout = 60;
  wait_for_server = 4;
	listen_socket { type=inet; port = 2525; }
	start_action = pass;
	# user = ${USER}; to trigger an error
	pass_fd_socket = smtps/smtpsfd;
	path = "../smtps/smtps";
	arguments = "smtps -f smx.conf";
}

smtpc {
  wait_for_server = 4;
  Log_Level = 12;
  IO_timeout = 66;
	start_action = wait;
	user = ${USER};
	path = "../smtpc/smtpc";
	arguments = "smtpc -f smx.conf";
}
EOF

if ./mcp -p ${PID} -D -T -d -i "" ${CNF} > ${OUT} 2>&1
then
  echo "$0: mcp did not fail as expected"
  ERRS=`expr ${ERRS} + 1 `
else
  if grep 'user: missing property' ${OUT} >/dev/null
  then
    :
  else
    echo "$0: missing error message"
    ERRS=`expr ${ERRS} + 1 `
  fi
fi

if ./mcp -p ${PID} -D -T -i "smtps" ${CNF} > ${OUT} 2>&1
then
  :
else
  echo "$0: mcp failed"
  ERRS=`expr ${ERRS} + 1 `
fi

# ----------------
if test ${ERRS} -eq 0
then
  rm -f ${PIDS} ${CNF} ${OUT} ${OK}
  exit 0
else
  echo "${ERRS} error(s)"
  exit 1
fi
